library ieee;
library std;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;



entity core_c is
  port(
    clk_i    : in std_logic;
    rst_i    : in std_logic;
    en_i     : in std_logic;
    wr_i     : in std_logic;
    bidir_io : inout std_logic_vector( 7 downto 0 )
      );
end entity;


architecture IMP of core_c is


  signal cnt : unsigned( 7 downto 0 );

begin

  p : process( clk, rst )
  begin
    if clk'event and clk='1' then

      if rst = '1' then
        cnt     <= ( others => '0' );
        bidir   <= ( others => 'Z' );
      else

        -- default case: we increase the counter
        cnt <= cnt+1;

        if en = '0' then

          if wr = '1' then
            cnt <= unsigned( bidir );
          end if;
          bidir <= ( others => 'Z' );
        else
          bidir <= std_logic_vector( cnt );
        end if;


      end if;

    end if;
  end process;
end architecture IMP;




